#exec Texture Import File=Textures\SBTriggeredRndAmbSnd.pcx Name=SBTriggeredRndAmbSnd Mips=Off Flags=2

class SBTriggeredRndAmbSnd extends KeyPoint;
var() sound Sounds[16]; // What to play

var byte Count; // current count of sounds




function CompactArray() {
local byte i, LastIndex;

	Count = 0;
	for (i = 0; i < ArrayCount(Sounds); i++)
	{
		if (Sounds[i] == None)
		{
			if (GetLastSound(LastIndex))
			{
				if (LastIndex > i)
				{
					Sounds[i] = Sounds[LastIndex];
					Sounds[LastIndex] = None;
				}
				else
					break; // no Sounds behind me any more
			}
			else
			{
				Disable('Trigger'); // no Sounds at all left
				break;
			}
		}
		Count++;
	}
}



function bool GetLastSound(out byte Index) {
/******************************************************************************
Looks for the last sound in array. If a sound was found, TRUE is returned and
*Index* is set to the index of that sound.
******************************************************************************/
local int i;

	for (i = ArrayCount(Sounds) - 1; i >= 0; i--)
		if (Sounds[i] != None)
		{
			Index = i;
			return true;
		}
	return false;
}



function PostBeginPlay () {
	CompactArray();
}



function Trigger(actor Other, pawn EventInstigator) {
	PlaySound(Sounds[rand(Count)], , Float(SoundVolume)/128, , Float(SoundRadius)*25);
}



defaultproperties {
	Texture=SBTriggeredRndAmbSnd
	SoundRadius=64
	SoundVolume=190
	SoundPitch=64
}
